PVXMLSession Class Reference

`#include <vxml.h>`

Inheritance diagram for PVXMLSession:

## Public Types

enum | TransferType { BridgedTransfer, BlindTransfer, ConsultationTransfer }
Public Types inherited from PChannel
enum | PXBlockType { PXReadBlock, PXWriteBlock, PXAcceptBlock, PXConnectBlock }
enum | ShutdownValue { ShutdownRead = 0, ShutdownWrite = 1, ShutdownReadAndWrite = 2 }
enum | Errors { NoError, NotFound, FileExists, DiskFull, AccessDenied, DeviceInUse, BadParameter, NoMemory, NotOpen, Timeout, Interrupted, BufferTooSmall, Miscellaneous, ProtocolFailure, NumNormalisedErrors }
| Normalised error codes. More...
enum | ErrorGroup { LastReadError, LastWriteError, LastGeneralError, NumErrorGroups }
| Error groups. More...
typedef std::vector< Slice > | VectorOfSlice
Public Types inherited from PObject
enum | Comparison { LessThan = -1, EqualTo = 0, GreaterThan = 1 }
| Result of the comparison operation performed by the `Compare()` function. More...

## Public Member Functions

| PVXMLSession (PTextToSpeech *tts=NULL, PBoolean autoDelete=false)
virtual | ~PVXMLSession ()
PTextToSpeech * | SetTextToSpeech (PTextToSpeech *tts, PBoolean autoDelete=false)
PTextToSpeech * | SetTextToSpeech (const PString &ttsName)
PTextToSpeech * | GetTextToSpeech () const
virtual PBoolean | Load (const PString &source)
virtual PBoolean | LoadFile (const PFilePath &file, const PString &firstForm=PString::Empty())
virtual PBoolean | LoadURL (const PURL &url)
virtual PBoolean | LoadVXML (const PString &xml, const PString &firstForm=PString::Empty())
virtual PBoolean | IsLoaded () const
virtual PBoolean | Open (const PString &mediaFormat)
virtual PBoolean | Close ()
| Close the channel. More...
virtual PBoolean | Execute ()
PVXMLChannel * | GetAndLockVXMLChannel ()
void | UnLockVXMLChannel ()
PMutex & | GetSessionMutex ()
virtual PBoolean | LoadGrammar (PVXMLGrammar *grammar)
virtual PBoolean | PlayText (const PString &text, PTextToSpeech::TextType type=PTextToSpeech::Default, PINDEX repeat=1, PINDEX delay=0)
PBoolean | ConvertTextToFilenameList (const PString &text, PTextToSpeech::TextType type, PStringArray &list, PBoolean useCacheing)
virtual PBoolean | PlayFile (const PString &fn, PINDEX repeat=1, PINDEX delay=0, PBoolean autoDelete=false)
virtual PBoolean | PlayData (const PBYTEArray &data, PINDEX repeat=1, PINDEX delay=0)
virtual PBoolean | PlayCommand (const PString &data, PINDEX repeat=1, PINDEX delay=0)
virtual PBoolean | PlayResource (const PURL &url, PINDEX repeat=1, PINDEX delay=0)
virtual PBoolean | PlayTone (const PString &toneSpec, PINDEX repeat=1, PINDEX delay=0)
virtual PBoolean | PlayElement (PXMLElement &element)
virtual PBoolean | PlaySilence (PINDEX msecs=0)
virtual PBoolean | PlaySilence (const PTimeInterval &timeout)
virtual PBoolean | PlayStop ()
virtual void | SetPause (PBoolean pause)
virtual void | GetBeepData (PBYTEArray &data, unsigned ms)
virtual PBoolean | StartRecording (const PFilePath &fn, PBoolean recordDTMFTerm, const PTimeInterval &recordMaxTime, const PTimeInterval &recordFinalSilence)
virtual PBoolean | EndRecording ()
virtual void | OnUserInput (const PString &str)
PString | GetXMLError () const
virtual void | OnEndDialog ()
virtual void | OnEndSession ()
virtual bool | OnTransfer (const PString &, TransferType)
void | SetTransferComplete (bool state)
const PStringToString & | GetVariables ()
virtual PCaselessString | GetVar (const PString &str) const
virtual void | SetVar (const PString &ostr, const PString &val)
virtual PString | EvaluateExpr (const PString &oexpr)
virtual PBoolean | RetreiveResource (const PURL &url, PString &contentType, PFilePath &fn, PBoolean useCache=true)
| PDECLARE_NOTIFIER (PThread, PVXMLSession, VXMLExecute)
bool | SetCurrentForm (const PString &id, bool fullURI)
bool | GoToEventHandler (PXMLElement &element, const PString &eventName)
virtual void | OnEndRecording ()
virtual void | Trigger ()
virtual PBoolean | TraverseAudio (PXMLElement &element)
virtual PBoolean | TraverseBreak (PXMLElement &element)
virtual PBoolean | TraverseValue (PXMLElement &element)
virtual PBoolean | TraverseSayAs (PXMLElement &element)
virtual PBoolean | TraverseGoto (PXMLElement &element)
virtual PBoolean | TraverseGrammar (PXMLElement &element)
virtual PBoolean | TraverseRecord (PXMLElement &element)
virtual PBoolean | TraversedRecord (PXMLElement &element)
virtual PBoolean | TraverseIf (PXMLElement &element)
virtual PBoolean | TraverseExit (PXMLElement &element)
virtual PBoolean | TraverseVar (PXMLElement &element)
virtual PBoolean | TraverseSubmit (PXMLElement &element)
virtual PBoolean | TraverseMenu (PXMLElement &element)
virtual PBoolean | TraversedMenu (PXMLElement &element)
virtual PBoolean | TraverseChoice (PXMLElement &element)
virtual PBoolean | TraverseProperty (PXMLElement &element)
virtual PBoolean | TraverseDisconnect (PXMLElement &element)
virtual PBoolean | TraverseForm (PXMLElement &element)
virtual PBoolean | TraversedForm (PXMLElement &element)
virtual PBoolean | TraversePrompt (PXMLElement &element)
virtual PBoolean | TraversedPrompt (PXMLElement &element)
virtual PBoolean | TraverseField (PXMLElement &element)
virtual PBoolean | TraversedField (PXMLElement &element)
virtual PBoolean | TraverseTransfer (PXMLElement &element)
virtual PBoolean | TraversedTransfer (PXMLElement &element)
__inline PVXMLChannel * | GetVXMLChannel () const
Public Member Functions inherited from PIndirectChannel
| PIndirectChannel ()
| Create a new indirect channel without any channels to redirect to. More...
| ~PIndirectChannel ()
| Close the indirect channel, deleting read/write channels if desired. More...
Comparison | Compare (const PObject &obj) const
| Determine if the two objects refer to the same indirect channel. More...
virtual PString | GetName () const
| Get the name of the channel. More...
virtual PBoolean | IsOpen () const
| Determine if the channel is currently open and read and write operations can be executed on it. More...
virtual PBoolean | Read (void *buf, PINDEX len)
| Low level read from the channel. More...
virtual PBoolean | Write (const void *buf, PINDEX len)
| Low level write to the channel. More...
virtual PBoolean | Shutdown (ShutdownValue option)
| Close one or both of the data streams associated with a channel. More...
virtual bool | SetLocalEcho (bool localEcho)
| Set local echo mode. More...
virtual PChannel * | GetBaseReadChannel () const
| This function returns the eventual base channel for reading of a series of indirect channels provided by descendents of `PIndirectChannel`. More...
virtual PChannel * | GetBaseWriteChannel () const
| This function returns the eventual base channel for writing of a series of indirect channels provided by descendents of `PIndirectChannel`. More...
virtual PString | GetErrorText (ErrorGroup group=NumErrorGroups) const
| Get error message description. More...
PBoolean | Open (PChannel &channel)
| Set the channel for both read and write operations. More...
PBoolean | Open (PChannel *channel, PBoolean autoDelete=true)
| Set the channel for both read and write operations. More...
PBoolean | Open (PChannel *readChannel, PChannel *writeChannel, PBoolean autoDeleteRead=true, PBoolean autoDeleteWrite=true)
| Set the channel for both read and write operations. More...
PChannel * | GetReadChannel () const
| Get the channel used for read operations. More...
bool | SetReadChannel (PChannel *channel, bool autoDelete=true, bool closeExisting=false)
| Set the channel for read operations. More...
PChannel * | GetWriteChannel () const
| Get the channel used for write operations. More...
PBoolean | SetWriteChannel (PChannel *channel, bool autoDelete=true, bool closeExisting=false)
| Set the channel for read operations. More...
Public Member Functions inherited from PChannel
PBoolean | SetErrorValues (Errors errorCode, int osError, ErrorGroup group=LastGeneralError)
| Set error values to those specified. More...
| PChannel ()
| Create the channel. More...
| ~PChannel ()
| Close down the channel. More...
virtual PINDEX | HashFunction () const
| Calculate a hash value for use in sets and dictionaries. More...
int | GetHandle () const
| Get the integer operating system handle for the channel. More...
void | SetReadTimeout (const PTimeInterval &time)
| Set the timeout for read operations. More...
PTimeInterval | GetReadTimeout () const
| Get the timeout for read operations. More...
virtual PINDEX | GetLastReadCount () const
| Get the number of bytes read by the last Read() call. More...
virtual int | ReadChar ()
| Read a single 8 bit byte from the channel. More...
PBoolean | ReadBlock (void *buf, PINDEX len)
| Read len bytes into the buffer from the channel. More...
PString | ReadString (PINDEX len)
| Read `len` character into a string from the channel. More...
virtual PBoolean | ReadAsync (void *buf, PINDEX len)
| Begin an asynchronous read from channel. More...
virtual void | OnReadComplete (void *buf, PINDEX len)
| User callback function for when a `ReadAsync()` call has completed or timed out. More...
void | SetWriteTimeout (const PTimeInterval &time)
| Set the timeout for write operations to complete. More...
PTimeInterval | GetWriteTimeout () const
| Get the timeout for write operations to complete. More...
virtual PBoolean | Write (const void *buf, PINDEX len, const void *mark)
| Low level write to the channel with marker. More...
virtual PINDEX | GetLastWriteCount () const
| Get the number of bytes written by the last Write() call. More...
PBoolean | WriteChar (int c)
| Write a single character to the channel. More...
PBoolean | WriteString (const PString &str)
| Write a string to the channel. More...
virtual PBoolean | WriteAsync (const void *buf, PINDEX len)
| Begin an asynchronous write from channel. More...
virtual void | OnWriteComplete (const void *buf, PINDEX len)
| User callback function for when a WriteAsync() call has completed or timed out. More...
virtual bool | FlowControl (const void *flowData)
| Flow Control information Pass data to the channel for flowControl determination. More...
PBoolean | SetBufferSize (PINDEX newSize)
| Set the iostream buffer size for reads and writes. More...
PBoolean | SendCommandString (const PString &command)
| Send a command meta-string. More...
void | AbortCommandString ()
| Abort a command string that is in progress. More...
Errors | GetErrorCode (ErrorGroup group=NumErrorGroups) const
| Get normalised error code. More...
int | GetErrorNumber (ErrorGroup group=NumErrorGroups) const
| Get OS errro code. More...
virtual PBoolean | Read (const VectorOfSlice &slices)
| Low level scattered read from the channel. More...
virtual PBoolean | Write (const VectorOfSlice &slices)
| Low level scattered write to the channel. More...
Public Member Functions inherited from PObject
virtual | ~PObject ()
virtual PObject * | Clone () const
| Create a copy of the class on the heap. More...
virtual const char * | GetClass (unsigned ancestor=0) const
| Get the current dynamic type of the object instance. More...
PBoolean | IsClass (const char *cls) const
virtual PBoolean | InternalIsDescendant (const char *clsName) const
| Determine if the dynamic type of the current instance is a descendent of the specified class. More...
virtual Comparison | CompareObjectMemoryDirect (const PObject &obj) const
| Determine the byte wise comparison of two objects. More...
bool | operator== (const PObject &obj) const
| Compare the two objects. More...
bool | operator!= (const PObject &obj) const
| Compare the two objects. More...
bool | operator< (const PObject &obj) const
| Compare the two objects. More...
bool | operator> (const PObject &obj) const
| Compare the two objects. More...
bool | operator<= (const PObject &obj) const
| Compare the two objects. More...
bool | operator>= (const PObject &obj) const
| Compare the two objects. More...
virtual void | PrintOn (ostream &strm) const
| Output the contents of the object to the stream. More...
virtual void | ReadFrom (istream &strm)
| Input the contents of the object from the stream. More...

## Static Public Member Functions

static PTimeInterval | StringToTime (const PString &str, int dflt=0)
Static Public Member Functions inherited from PChannel
static PBoolean | ConvertOSError (int libcReturnValue, Errors &lastError, int &osError)
| Convert an operating system error into platform independent error. More...
static PString | GetErrorText (Errors lastError, int osError=0)
| Get error message description. More...
Static Public Member Functions inherited from PObject
static const char * | Class ()
| Get the name of the class as a C string. More...
static Comparison | InternalCompareObjectMemoryDirect (const PObject *obj1, const PObject *obj2, PINDEX size)
| Internal function caled from CompareObjectMemoryDirect() More...

## Protected Types

enum | { NotRecording, RecordingInProgress, RecordingComplete }
enum | { NotTransfering, TransferInProgress, TransferFailed, TransferSuccessful }

## Protected Member Functions

virtual bool | InternalLoadVXML (const PString &xml, const PString &firstForm)
virtual bool | ProcessNode ()
virtual bool | ProcessEvents ()
virtual bool | ProcessGrammar ()
virtual bool | NextNode (bool processChildren)
void | SayAs (const PString &className, const PString &text)
void | SayAs (const PString &className, const PString &text, const PString &voice)
PURL | NormaliseResourceName (const PString &src)
Protected Member Functions inherited from PIndirectChannel
virtual PBoolean | OnOpen ()
| This callback is executed when the Open() function is called with open channels. More...
Protected Member Functions inherited from PChannel
| PChannel (const PChannel &)
PChannel & | operator= (const PChannel &)
virtual PBoolean | ConvertOSError (int libcReturnValue, ErrorGroup group=LastGeneralError)
| Convert an operating system error into platform independent error. More...
int | ReadCharWithTimeout (PTimeInterval &timeout)
| Read a character with specified timeout. More...
PBoolean | ReceiveCommandString (int nextChar, const PString &reply, PINDEX &pos, PINDEX start)
PBoolean | PXSetIOBlock (PXBlockType type, const PTimeInterval &timeout)
int | PXClose ()
Protected Member Functions inherited from PObject
| PObject ()
| Constructor for PObject, made protected so cannot ever create one on its own. More...

## Protected Attributes

PMutex | m_sessionMutex
PURL | m_rootURL
PXML | m_xml
PTextToSpeech * | m_textToSpeech
bool | m_autoDeleteTextToSpeech
PThread * | m_vxmlThread
bool | m_abortVXML
PSyncPoint | m_waitForEvent
PXMLObject * | m_currentNode
bool | m_xmlChanged
bool | m_speakNodeData
bool | m_bargeIn
bool | m_bargingIn
PVXMLGrammar * | m_grammar
char | m_defaultMenuDTMF
PStringToString | m_variables
PString | m_variableScope
std::queue< char > | m_userInputQueue
PMutex | m_userInputMutex
enum PVXMLSession:: { ... } | m_recordingStatus
bool | m_recordStopOnDTMF
enum PVXMLSession:: { ... } | m_transferStatus
PTime | m_transferStartTime
Protected Attributes inherited from PIndirectChannel
PChannel * | readChannel
| Channel for read operations. More...
PBoolean | readAutoDelete
| Automatically delete read channel on destruction. More...
PChannel * | writeChannel
| Channel for write operations. More...
PBoolean | writeAutoDelete
| Automatically delete write channel on destruction. More...
PReadWriteMutex | channelPointerMutex
| Race condition prevention on closing channel. More...
Protected Attributes inherited from PChannel
int | os_handle
| The operating system file handle return by standard open() function. More...
Errors | lastErrorCode [NumErrorGroups+1]
| The platform independant error code. More...
int | lastErrorNumber [NumErrorGroups+1]
| The operating system error number (eg as returned by errno). More...
PINDEX | lastReadCount
| Number of byte last read by the Read() function. More...
PINDEX | lastWriteCount
| Number of byte last written by the Write() function. More...
PTimeInterval | readTimeout
| Timeout for read operations. More...
PTimeInterval | writeTimeout
| Timeout for write operations. More...
PString | channelName
PMutex | px_threadMutex
PXBlockType | px_lastBlockType
PThread * | px_readThread
PThread * | px_writeThread
PMutex | px_writeMutex
PThread * | px_selectThread [3]
PMutex | px_selectMutex [3]

## Member Enumeration Documentation

## anonymous enum

anonymous enum

protected

Enumerator
NotRecording |
RecordingInProgress |
RecordingComplete |

## anonymous enum

anonymous enum

protected

Enumerator
NotTransfering |
TransferInProgress |
TransferFailed |
TransferSuccessful |

## TransferType

enum PVXMLSession::TransferType

Enumerator
BridgedTransfer |
BlindTransfer |
ConsultationTransfer |

## Constructor & Destructor Documentation

## PVXMLSession()

PVXMLSession::PVXMLSession | ( | PTextToSpeech * | tts = `NULL`,
|  | PBoolean | autoDelete = `false`
| ) |  |

## ~PVXMLSession()

virtual PVXMLSession::~PVXMLSession | ( |  | ) |

virtual

## Member Function Documentation

## Close()

virtual PBoolean PVXMLSession::Close | ( |  | ) |

virtual

Close the channel.

This will detach itself from the read and write channels and delete both of them if they are auto delete.

Returns
  true if the channel is closed.

Reimplemented from PIndirectChannel.

## ConvertTextToFilenameList()

PBoolean PVXMLSession::ConvertTextToFilenameList | ( | const PString & | text,
|  | PTextToSpeech::TextType | type,
|  | PStringArray & | list,
|  | PBoolean | useCacheing
| ) |  |

## EndRecording()

virtual PBoolean PVXMLSession::EndRecording | ( |  | ) |

virtual

## EvaluateExpr()

virtual PString PVXMLSession::EvaluateExpr | ( | const PString & | oexpr | ) |

virtual

## Execute()

virtual PBoolean PVXMLSession::Execute | ( |  | ) |

virtual

## GetAndLockVXMLChannel()

PVXMLChannel* PVXMLSession::GetAndLockVXMLChannel | ( |  | ) |

## GetBeepData()

virtual void PVXMLSession::GetBeepData | ( | PBYTEArray & | data,
|  | unsigned | ms
| ) |  |

virtual

## GetSessionMutex()

PMutex& PVXMLSession::GetSessionMutex | ( |  | ) |

inline

References PVXMLGrammar::OnUserInput().

## GetTextToSpeech()

PTextToSpeech* PVXMLSession::GetTextToSpeech | ( |  | ) | const

inline

References PString::Empty().

## GetVar()

virtual PCaselessString PVXMLSession::GetVar | ( | const PString & | str | ) | const

virtual

## GetVariables()

const PStringToString& PVXMLSession::GetVariables | ( |  | ) |

inline

References PVXMLGrammar::PDECLARE_NOTIFIER().

## GetVXMLChannel()

__inline PVXMLChannel* PVXMLSession::GetVXMLChannel | ( |  | ) | const

inline

## GetXMLError()

PString PVXMLSession::GetXMLError | ( |  | ) | const

## GoToEventHandler()

bool PVXMLSession::GoToEventHandler | ( | PXMLElement & | element,
|  | const PString & | eventName
| ) |  |

## InternalLoadVXML()

virtual bool PVXMLSession::InternalLoadVXML | ( | const PString & | xml,
|  | const PString & | firstForm
| ) |  |

protected virtual

## IsLoaded()

virtual PBoolean PVXMLSession::IsLoaded | ( |  | ) | const

inline virtual

## Load()

virtual PBoolean PVXMLSession::Load | ( | const PString & | source | ) |

virtual

## LoadFile()

virtual PBoolean PVXMLSession::LoadFile | ( | const PFilePath & | file,
|  | const PString & | firstForm = `PString::Empty()`
| ) |  |

virtual

## LoadGrammar()

virtual PBoolean PVXMLSession::LoadGrammar | ( | PVXMLGrammar * | grammar | ) |

virtual

## LoadURL()

virtual PBoolean PVXMLSession::LoadURL | ( | const PURL & | url | ) |

virtual

## LoadVXML()

virtual PBoolean PVXMLSession::LoadVXML | ( | const PString & | xml,
|  | const PString & | firstForm = `PString::Empty()`
| ) |  |

virtual

## NextNode()

virtual bool PVXMLSession::NextNode | ( | bool | processChildren | ) |

protected virtual

## NormaliseResourceName()

PURL PVXMLSession::NormaliseResourceName | ( | const PString & | src | ) |

protected

## OnEndDialog()

virtual void PVXMLSession::OnEndDialog | ( |  | ) |

virtual

## OnEndRecording()

virtual void PVXMLSession::OnEndRecording | ( |  | ) |

virtual

## OnEndSession()

virtual void PVXMLSession::OnEndSession | ( |  | ) |

virtual

## OnTransfer()

virtual bool PVXMLSession::OnTransfer | ( | const PString & | ,
|  | TransferType |
| ) |  |

inline virtual

## OnUserInput()

virtual void PVXMLSession::OnUserInput | ( | const PString & | str | ) |

virtual

## Open()

virtual PBoolean PVXMLSession::Open | ( | const PString & | mediaFormat | ) |

virtual

## PDECLARE_NOTIFIER()

PVXMLSession::PDECLARE_NOTIFIER | ( | PThread | ,
|  | PVXMLSession | ,
|  | VXMLExecute |
| ) |  |

## PlayCommand()

virtual PBoolean PVXMLSession::PlayCommand | ( | const PString & | data,
|  | PINDEX | repeat = `1`,
|  | PINDEX | delay = `0`
| ) |  |

virtual

## PlayData()

virtual PBoolean PVXMLSession::PlayData | ( | const PBYTEArray & | data,
|  | PINDEX | repeat = `1`,
|  | PINDEX | delay = `0`
| ) |  |

virtual

## PlayElement()

virtual PBoolean PVXMLSession::PlayElement | ( | PXMLElement & | element | ) |

virtual

## PlayFile()

virtual PBoolean PVXMLSession::PlayFile | ( | const PString & | fn,
|  | PINDEX | repeat = `1`,
|  | PINDEX | delay = `0`,
|  | PBoolean | autoDelete = `false`
| ) |  |

virtual

## PlayResource()

virtual PBoolean PVXMLSession::PlayResource | ( | const PURL & | url,
|  | PINDEX | repeat = `1`,
|  | PINDEX | delay = `0`
| ) |  |

virtual

## PlaySilence() [1/2]

virtual PBoolean PVXMLSession::PlaySilence | ( | PINDEX | msecs = `0` | ) |

virtual

## PlaySilence() [2/2]

virtual PBoolean PVXMLSession::PlaySilence | ( | const PTimeInterval & | timeout | ) |

virtual

## PlayStop()

virtual PBoolean PVXMLSession::PlayStop | ( |  | ) |

virtual

## PlayText()

virtual PBoolean PVXMLSession::PlayText | ( | const PString & | text,
|  | PTextToSpeech::TextType | type = `PTextToSpeech::Default`,
|  | PINDEX | repeat = `1`,
|  | PINDEX | delay = `0`
| ) |  |

virtual

## PlayTone()

virtual PBoolean PVXMLSession::PlayTone | ( | const PString & | toneSpec,
|  | PINDEX | repeat = `1`,
|  | PINDEX | delay = `0`
| ) |  |

virtual

## ProcessEvents()

virtual bool PVXMLSession::ProcessEvents | ( |  | ) |

protected virtual

## ProcessGrammar()

virtual bool PVXMLSession::ProcessGrammar | ( |  | ) |

protected virtual

## ProcessNode()

virtual bool PVXMLSession::ProcessNode | ( |  | ) |

protected virtual

## RetreiveResource()

virtual PBoolean PVXMLSession::RetreiveResource | ( | const PURL & | url,
|  | PString & | contentType,
|  | PFilePath & | fn,
|  | PBoolean | useCache = `true`
| ) |  |

virtual

## SayAs() [1/2]

void PVXMLSession::SayAs | ( | const PString & | className,
|  | const PString & | text
| ) |  |

protected

## SayAs() [2/2]

void PVXMLSession::SayAs | ( | const PString & | className,
|  | const PString & | text,
|  | const PString & | voice
| ) |  |

protected

## SetCurrentForm()

bool PVXMLSession::SetCurrentForm | ( | const PString & | id,
|  | bool | fullURI
| ) |  |

## SetPause()

virtual void PVXMLSession::SetPause | ( | PBoolean | pause | ) |

virtual

## SetTextToSpeech() [1/2]

PTextToSpeech* PVXMLSession::SetTextToSpeech | ( | PTextToSpeech * | tts,
|  | PBoolean | autoDelete = `false`
| ) |  |

## SetTextToSpeech() [2/2]

PTextToSpeech* PVXMLSession::SetTextToSpeech | ( | const PString & | ttsName | ) |

## SetTransferComplete()

void PVXMLSession::SetTransferComplete | ( | bool | state | ) |

## SetVar()

virtual void PVXMLSession::SetVar | ( | const PString & | ostr,
|  | const PString & | val
| ) |  |

virtual

## StartRecording()

virtual PBoolean PVXMLSession::StartRecording | ( | const PFilePath & | fn,
|  | PBoolean | recordDTMFTerm,
|  | const PTimeInterval & | recordMaxTime,
|  | const PTimeInterval & | recordFinalSilence
| ) |  |

virtual

## StringToTime()

static PTimeInterval PVXMLSession::StringToTime | ( | const PString & | str,
|  | int | dflt = `0`
| ) |  |

static

## TraverseAudio()

virtual PBoolean PVXMLSession::TraverseAudio | ( | PXMLElement & | element | ) |

virtual

## TraverseBreak()

virtual PBoolean PVXMLSession::TraverseBreak | ( | PXMLElement & | element | ) |

virtual

## TraverseChoice()

virtual PBoolean PVXMLSession::TraverseChoice | ( | PXMLElement & | element | ) |

virtual

## TraversedField()

virtual PBoolean PVXMLSession::TraversedField | ( | PXMLElement & | element | ) |

virtual

## TraversedForm()

virtual PBoolean PVXMLSession::TraversedForm | ( | PXMLElement & | element | ) |

virtual

## TraverseDisconnect()

virtual PBoolean PVXMLSession::TraverseDisconnect | ( | PXMLElement & | element | ) |

virtual

## TraversedMenu()

virtual PBoolean PVXMLSession::TraversedMenu | ( | PXMLElement & | element | ) |

virtual

## TraversedPrompt()

virtual PBoolean PVXMLSession::TraversedPrompt | ( | PXMLElement & | element | ) |

virtual

## TraversedRecord()

virtual PBoolean PVXMLSession::TraversedRecord | ( | PXMLElement & | element | ) |

virtual

## TraversedTransfer()

virtual PBoolean PVXMLSession::TraversedTransfer | ( | PXMLElement & | element | ) |

virtual

## TraverseExit()

virtual PBoolean PVXMLSession::TraverseExit | ( | PXMLElement & | element | ) |

virtual

## TraverseField()

virtual PBoolean PVXMLSession::TraverseField | ( | PXMLElement & | element | ) |

virtual

## TraverseForm()

virtual PBoolean PVXMLSession::TraverseForm | ( | PXMLElement & | element | ) |

virtual

## TraverseGoto()

virtual PBoolean PVXMLSession::TraverseGoto | ( | PXMLElement & | element | ) |

virtual

## TraverseGrammar()

virtual PBoolean PVXMLSession::TraverseGrammar | ( | PXMLElement & | element | ) |

virtual

## TraverseIf()

virtual PBoolean PVXMLSession::TraverseIf | ( | PXMLElement & | element | ) |

virtual

## TraverseMenu()

virtual PBoolean PVXMLSession::TraverseMenu | ( | PXMLElement & | element | ) |

virtual

## TraversePrompt()

virtual PBoolean PVXMLSession::TraversePrompt | ( | PXMLElement & | element | ) |

virtual

## TraverseProperty()

virtual PBoolean PVXMLSession::TraverseProperty | ( | PXMLElement & | element | ) |

virtual

## TraverseRecord()

virtual PBoolean PVXMLSession::TraverseRecord | ( | PXMLElement & | element | ) |

virtual

## TraverseSayAs()

virtual PBoolean PVXMLSession::TraverseSayAs | ( | PXMLElement & | element | ) |

virtual

## TraverseSubmit()

virtual PBoolean PVXMLSession::TraverseSubmit | ( | PXMLElement & | element | ) |

virtual

## TraverseTransfer()

virtual PBoolean PVXMLSession::TraverseTransfer | ( | PXMLElement & | element | ) |

virtual

## TraverseValue()

virtual PBoolean PVXMLSession::TraverseValue | ( | PXMLElement & | element | ) |

virtual

## TraverseVar()

virtual PBoolean PVXMLSession::TraverseVar | ( | PXMLElement & | element | ) |

virtual

## Trigger()

virtual void PVXMLSession::Trigger | ( |  | ) |

virtual

## UnLockVXMLChannel()

void PVXMLSession::UnLockVXMLChannel | ( |  | ) |

inline

## Member Data Documentation

## m_abortVXML

bool PVXMLSession::m_abortVXML

protected

## m_autoDeleteTextToSpeech

bool PVXMLSession::m_autoDeleteTextToSpeech

protected

## m_bargeIn

bool PVXMLSession::m_bargeIn

protected

## m_bargingIn

bool PVXMLSession::m_bargingIn

protected

## m_currentNode

PXMLObject* PVXMLSession::m_currentNode

protected

## m_defaultMenuDTMF

char PVXMLSession::m_defaultMenuDTMF

protected

## m_grammar

PVXMLGrammar* PVXMLSession::m_grammar

protected

## m_recordingStatus

enum { ... } PVXMLSession::m_recordingStatus

## m_recordStopOnDTMF

bool PVXMLSession::m_recordStopOnDTMF

protected

## m_rootURL

PURL PVXMLSession::m_rootURL

protected

## m_sessionMutex

PMutex PVXMLSession::m_sessionMutex

protected

## m_speakNodeData

bool PVXMLSession::m_speakNodeData

protected

## m_textToSpeech

PTextToSpeech* PVXMLSession::m_textToSpeech

protected

## m_transferStartTime

PTime PVXMLSession::m_transferStartTime

protected

## m_transferStatus

enum { ... } PVXMLSession::m_transferStatus

## m_userInputMutex

PMutex PVXMLSession::m_userInputMutex

protected

## m_userInputQueue

std::queue<char> PVXMLSession::m_userInputQueue

protected

## m_variables

PStringToString PVXMLSession::m_variables

protected

## m_variableScope

PString PVXMLSession::m_variableScope

protected

## m_vxmlThread

PThread* PVXMLSession::m_vxmlThread

protected

## m_waitForEvent

PSyncPoint PVXMLSession::m_waitForEvent

protected

## m_xml

PXML PVXMLSession::m_xml

protected

## m_xmlChanged

bool PVXMLSession::m_xmlChanged

protected

The documentation for this class was generated from the following file:

- vxml.h